#ifndef CLIENTDIALOG_H
#define CLIENTDIALOG_H
#include <QtGui>
#include <QtNetwork>
#include <QTcpServer>

class ClientDialog : public QDialog
{
  Q_OBJECT

public:
  ClientDialog();
  virtual ~ ClientDialog();

private slots:
  void connectServer();
  void reportConnected(); 
  void reportHostFound();
  void getMessage();
  void connectionClosed();
  void changeQuestion(bool);
  void closeSocket();

private:
  void createServerGroupBox();
  void createAnswerGroupBox();
  void createQuestionGroupBox();
  /* server group */
  QGroupBox *serverGroupBox;
  QLabel * serverLabel;
  QLabel * portLabel;
  QLineEdit * serverName;
  QLineEdit * portNumber;
  QPushButton * connectButton;
  /* answers from server */
  QGroupBox * answerGroupBox;
  QTextEdit * mathAnswer;
  /* questions */
  QGroupBox *questionGroupBox;
  QRadioButton * additionRadioButton;
  QRadioButton * subtractionRadioButton;
  QRadioButton * multiplicationRadioButton;
  QPushButton * closeButton;
  QTcpSocket * socket;
  bool isConnected;
  enum QuestionType {ADDITION, SUBTRACTION, 
		     MULTIPLICATION, UNKNOWN}; 
};

#endif
