/*
 * ServerInfo.java
 *
 * Created on February 10, 2008, 9:35 PM
 */
package mathserver;

import java.io.IOException;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author  yunglu
 */
public class ServerInfo extends javax.swing.JFrame {

    /** Creates new form ServerInfo */
    public ServerInfo() {
        initComponents();
        try {
            hostLabel.setText("Host Name: " +
                    InetAddress.getLocalHost().getHostAddress());
        } catch (UnknownHostException exp) {
            hostLabel.setText("Host Name: unknown");
        }
        try {
            siSocket = new ServerSocket(0); // 0 to get an available port
            portLabel.setText("Port Number: " + siSocket.getLocalPort());
        } catch (IOException exp) {
            portLabel.setText("Port Number: unknown");
        }
    }

    public void startServer() {
        siList = new ArrayList<ClientHandler>();
        try {
            while (true) {
                Socket sock = siSocket.accept();
                System.out.println("A new client connection");
                ClientHandler clh = new ClientHandler(sock);
                siList.add(clh);
                clh.start();
            }
        } catch (Exception e) {
            System.out.println(e);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        hostLabel = new javax.swing.JLabel();
        portLabel = new javax.swing.JLabel();
        closeButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        hostLabel.setText("Host IP:");

        portLabel.setText("Port Number:");

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(30, 30, 30)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(portLabel)
                            .add(hostLabel)))
                    .add(layout.createSequentialGroup()
                        .add(50, 50, 50)
                        .add(closeButton)))
                .addContainerGap(78, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(hostLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(portLabel)
                .add(18, 18, 18)
                .add(closeButton)
                .addContainerGap(17, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // TODO add your handling code here:
        System.exit(0);
}//GEN-LAST:event_closeButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new ServerInfo().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JLabel hostLabel;
    private javax.swing.JLabel portLabel;
    // End of variables declaration//GEN-END:variables
    private ServerSocket siSocket;
    private List<ClientHandler> siList;
}
